package cn.com.qmth.examcloud.core.examwork.service.cache;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import cn.com.qmth.examcloud.core.examwork.service.ExamService;
import cn.com.qmth.examcloud.support.cache.bean.ExamOrgPropertyCacheBean;
import cn.com.qmth.examcloud.web.cache.RandomObjectRedisCache;

@Service
public class ExamOrgPropertyCache extends RandomObjectRedisCache<ExamOrgPropertyCacheBean> {

	@Autowired
	private ExamService examService;

	@Override
	public ExamOrgPropertyCacheBean loadFromResource(Object... keys) {
		Long examId = (Long) keys[0];
		Long orgId = (Long) keys[1];
		String key = (String) keys[2];

		String value = examService.getOrgProperty(examId, orgId, key);

		ExamOrgPropertyCacheBean b = new ExamOrgPropertyCacheBean();
		b.setExamId(examId);
		b.setOrgId(orgId);
		b.setKey(key);
		b.setValue(value);
		return b;
	}

	@Override
	protected String getKeyPrefix() {
		return "E_EXAM_ORG_PROP:";
	}

	@Override
	protected int getTimeout() {
		// 1分钟
		return 60;
	}

}
